
#include <Wire.h>
#include <Eeprom24C01_02.h>
int i2cadress;

void setup()
{
  Wire.begin();
 
  Serial.begin(9600);
  while (!Serial);
  ScanI2C();
}
 
void loop()
{
}

void ScanI2C()
{
  byte error, adress;
  int nDevices;
 
  Serial.println("Scanning I2C...");
 
  nDevices = 0;
  for(adress = 1; adress < 127; adress++ )
  {

    Wire.beginTransmission(adress);
    error = Wire.endTransmission();
 
    if (error == 0)
    {
      Serial.print("I2C device found at adress 0x");
      if (adress<16)
      Serial.print("0");
      Serial.print(adress,HEX);
      Serial.println("  !");
      Serial.println("r-read, w-write");
      i2cadress = adress;
      nDevices++;
      break;
    }
    else if (error==4)
    {
      Serial.print("Unknow error at adress 0x");
      if (adress<16)
        Serial.print("0");
      Serial.println(adress,HEX);
    }    
  }
  if (nDevices == 0)
    Serial.println("No I2C devices found\n");
}

void ReadI2C()
{
static Eeprom24C01_02 eeprom(i2cadress);
eeprom.initialize();
Serial.println("Read 256 bytes from EEPROM memory...");
for(int i = 0; i<=255;i++){
byte data = eeprom.readByte(i);
Serial.print(data, HEX);
}
Serial.println("");
Serial.println("Read Done");
}

void WriteI2C()
{
static Eeprom24C01_02 eeprom(i2cadress);
eeprom.initialize();
Serial.println("Write 256 bytes from EEPROM memory...");
for(int i = 0; i<=255;i++){
eeprom.writeByte(i, 0x00);
delay(10);
}
eeprom.writeByte(125, 0x55);
delay(10);
eeprom.writeByte(126, 0xAA);
delay(10);
eeprom.writeByte(254, 0xFF);
delay(10);
eeprom.writeByte(255, 0xFF);
delay(10);
Serial.println("Write Done");
}

void serialEvent() {
  while (Serial.available()) {
    char inputChar = (char)Serial.read(); 
  
      if(inputChar == 'r' & i2cadress < 127) {
      ReadI2C();
      }
      
      if(inputChar == 'w'  & i2cadress < 127) {
      WriteI2C();
      }     
    } 
  }
